#define ID_FILE_LAB1                     132780
#define ID_FILE_MAB1                     132781
#define ID_FILE_CAB1                     132782
#define ID_FILE_TAB1                     132783
#define ID_ENJOY1                        132785


WNDPROC _wndProc;
WINAPI CALLBACK MenuDialogProc(HWND hDlg,UINT message,WPARAM wParam, LPARAM lParam);


void CreateOwnerDrawPopUpMenu(HWND m_hWnd,HINSTANCE hInst) 
{
	HWND hndD;
	HMENU hMainMenu=NULL;
	HMENU hPopUpMenu=NULL;
	HMENU hPopUpMenu1=NULL;

	hMainMenu = CreateMenu();
	
	hPopUpMenu = CreateMenu();
	::AppendMenu(hPopUpMenu,MF_STRING|MF_OWNERDRAW,ID_FILE_LAB1,"Lab");
	::AppendMenu(hPopUpMenu,MF_STRING|MF_OWNERDRAW,ID_FILE_MAB1,"Mab");
	::AppendMenu(hPopUpMenu,MF_STRING|MF_OWNERDRAW,ID_FILE_CAB1,"Cab");
	::AppendMenu(hPopUpMenu,MF_STRING|MF_OWNERDRAW,ID_FILE_TAB1,"Tab");

	::AppendMenu(hMainMenu,MF_POPUP,(UINT)hPopUpMenu,"Sala");

	hPopUpMenu1 = CreateMenu();
	::AppendMenu(hPopUpMenu1,MF_STRING|MF_OWNERDRAW,ID_ENJOY1,"Enjoy");
	::AppendMenu(hPopUpMenu,MF_POPUP|MF_OWNERDRAW,(UINT)hPopUpMenu1,"Sala");

	static DLGTEMPLATE DlgTmpl; //global dialog template in memory
	DlgTmpl.style=DS_CENTER|WS_CAPTION | WS_SYSMENU |WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_THICKFRAME;
	DlgTmpl.dwExtendedStyle=0;
	DlgTmpl.cx=200;
	DlgTmpl.cy=100;
	DlgTmpl.x=100;
	DlgTmpl.y=100;
	DlgTmpl.cdit=0;
	
	//a dummy dialog in memory for bouncing messages to your main window
	hndD=CreateDialogIndirectParam(hInst,&DlgTmpl,m_hWnd,MenuDialogProc,(LPARAM)m_hWnd);
	SetWindowText(hndD,"Sonilabamba");
	::SetMenu(hndD,hMainMenu);
	//::SendMessage(hndD,WM_DESTROY,0,0);
	//::EndDialog(hndD,0);
	//::ShowWindow(hndD,SW_SHOW); 
}

WINAPI CALLBACK MenuDialogProc(HWND hDlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	//Store the owner window handle here
	static HWND Owner;
	switch(message)
	{
		case WM_INITDIALOG:
			Owner = (HWND)lParam;			
		return TRUE;

		case WM_SYSCOMMAND:
			if(wParam == SC_CLOSE)
				//Modeless window do call ::DestroyWindow(hDlg);
				::DestroyWindow(hDlg);
		break;
		//Bouce back these messages to the owner window 
		case WM_MEASUREITEM:
		case WM_DRAWITEM:
			::SendMessage(Owner,message,wParam,lParam); 
		return TRUE;
	}
	return FALSE;
}

LRESULT CALLBACK WindowProcMain(HWND hwnd,UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
    	case WM_CONTEXTMENU:
		{
			HWND hwnd = (HWND) wParam; 
			int xPos = LOWORD(lParam); 
			int yPos = HIWORD(lParam); 
			HWND hd = ::FindWindow(NULL,"Sonilabamba");
			HMENU hmnu = ::GetSubMenu(::GetMenu(hd),0);
			TrackPopupMenu(hmnu,0,xPos,yPos,0,hd,0);
			
		}
		return 1;
	}

	return CallWindowProc(_wndProc, hwnd, message, wParam, lParam);
}

void InitPopUpMenu()
{
	HWND m_hWnd = AfxGetMainWnd()->m_hWnd;
	CreateOwnerDrawPopUpMenu(m_hWnd,AfxGetInstanceHandle());
	_wndProc = (WNDPROC)SetWindowLong(m_hWnd, GWL_WNDPROC, (long)WindowProcMain);	
}

/*
Owner Draw Context menu in a dialog application
Well if you ask what's so different with a context menu, then try making a context 
menu owner draw which has a pop-up menu in it. at the same time removing the reference 
of the menu from the dialog. You won't be able make the pop-up menu element owner draw so easily. 
So here is an easier approach.
Popup menu items can be easily made owner draw if there is a menu already present in the dialog.
But what if you wnat only the context menu and not the main menu to be displayed. Host a 
surrogate dialog window. For creating the dialog window I do not make use of any resouce, I 
use the rarely used CreateDialogIndirectParam(...) win32 API. It uses only a structure 
varaible  of the type DLGTEMPLATE (see MDSN) and most importantly a Callback function to act 
as a dialog procedure. So I host the menu in the dynamically created dialog hide the dialog,
and before that I make use of some traditional Pedzold coding to create a menu dynamically. See 
the function CreateOwnerDrawPopUpMenu().

The action actually beguns much before the menu and the dialog gets created. It all happens 
when InitPopUpMenu() is called in OnInitDialog(). In InitPopUpMenu() I make a call to 
CreateOwnerDrawPopUpMenu()  and hook the main dialog's window procedure. I do this because only
I and not the main program knows where is the context, in the WindowProcMain(..) function, I 
trap the WM_CONTEXTMENU message and retrieve the menu from the surrogate dialog and call 
TrackPopupMenu(..) to display the context menu.

Now is when the real action starts. The menu belongs to the surrogate dialog, and since the menu 
is owner draw messages, WM_MEASUREITEM and WM_DRAWITEM go only to the surrogate dialog. But if 
you see the source code they are handled in the main dilaog and not in the surrogate , how is 
this magic achieved? This is no magic. When is call CreateDialogIndirectParam(..) I secretly 
send in the main window handle as the last paramter, this parameter shows up as lParam value
in the WM_INITDIALOG message of the surrogate and I tuck it away in the Owner varaible for 
future use. Once having saved the handle of thwe Owner , when WM_MEASUREITEM and WM_DRAWITEM
messages come I simply call :SendMessage(Owner,message,wParam,lParam) bouncing them back to
the main dialog.
*/





